diff --git a/src/gui/PlayClass.hpp b/src/gui/PlayClass.hpp
index 7a9a688e..eeddf6d4 100644
--- a/src/gui/PlayClass.hpp
+++ b/src/gui/PlayClass.hpp
@@ -45,7 +45,7 @@ inline constexpr double SEEK_NOWHERE = -1.0;
 inline constexpr double SEEK_STREAM_RELOAD = -2.0; // Seeks to current position after stream reload
 inline constexpr double SEEK_REPEAT = -3.0;
 
-class PlayClass final : public QObject
+class PlayClass : public QObject
 {
     Q_OBJECT
     friend class DemuxerThr;
@@ -92,13 +92,16 @@ public:
         doSilenceOnStart = true;
     }
 
+public slots:
     void setKeepAudioPitch(bool keep);
 
+public:
     inline void setDontResetContinuePlayback(bool val)
     {
         dontResetContinuePlayback = val;
     }
 
+public slots:
     void setRecording(bool checked);
 
     void setIntegerScaling(bool integerScaling);
@@ -193,7 +196,7 @@ private slots:
 
     void saveCover();
     void settingsChanged(int page, bool forceRestart, bool initFilters);
-public:
+public slots:
     void videoResized(const QSize &size);
 
 private slots:
@@ -205,12 +208,12 @@ private slots:
     void setSpeed();
     void zoomIn();
     void zoomOut();
-public:
+public slots:
     void setZoom();
 private slots:
     void zoomReset();
     void otherReset();
-public:
+public slots:
     void aRatio();
 private slots:
     void volume(int, int);
@@ -243,6 +246,9 @@ private slots:
     void timTerminateFinished();
 
     void load(Demuxer *);
+
+    // Qt4: Helper slot for lambda conversion
+    void handleDemuxerRecording(bool status, bool error, const QString &fileName);
 signals:
     void frameSizeUpdate(int w, int h);
     void audioParamsUpdate(quint8 channels, quint32 sampleRate);
diff --git a/src/gui/PlaylistDock.cpp b/src/gui/PlaylistDock.cpp
index 2084e53a..c2e83297 100644
--- a/src/gui/PlaylistDock.cpp
+++ b/src/gui/PlaylistDock.cpp
@@ -35,7 +35,12 @@
 #include <QPainter>
 #include <QAction>
 #include <QMessageBox>
-#include <QRandomGenerator>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
+    #include <QRandomGenerator>
+#else
+    #include <QtGlobal>
+    #include <cstdlib>
+#endif
 
 static bool urlMatchesWithItem(QTreeWidgetItem *item, const QString &url)
 {
@@ -50,6 +55,11 @@ PlaylistDock::PlaylistDock() :
     repeatMode(RepeatNormal),
     lastPlaying(nullptr)
 {
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    // Qt4: Register the metatype at runtime
+    qRegisterMetaType<ByteArrayHash>("ByteArrayHash");
+    qRegisterMetaType<ByteArrayHash>("QHash<QByteArray,QByteArray>");
+#endif
     setWindowTitle(tr("Playlist"));
     setWidget(&mainW);
 
@@ -69,7 +79,7 @@ PlaylistDock::PlaylistDock() :
 
     connect(list, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)), this, SLOT(itemDoubleClicked(QTreeWidgetItem *)));
     connect(list, SIGNAL(returnItem(QTreeWidgetItem *)), this, SLOT(addAndPlay(QTreeWidgetItem *)));
-    connect(list, &PlaylistWidget::itemExpanded, this, &PlaylistDock::maybeDoQuickSync, Qt::QueuedConnection); // Must be queued to not crash at startup in some cases
+    connect(list, SIGNAL(itemExpanded(QTreeWidgetItem *)), this, SLOT(maybeDoQuickSync(QTreeWidgetItem *)), Qt::QueuedConnection); // Must be queued to not crash at startup in some cases
     connect(list, SIGNAL(visibleItemsCount(int)), this, SLOT(visibleItemsCount(int)));
     connect(list, SIGNAL(addStatus(bool)), findE, SLOT(setDisabled(bool)));
     connect(findE, SIGNAL(textChanged(const QString &)), this, SLOT(findItems(const QString &)));
@@ -370,7 +380,11 @@ void PlaylistDock::itemDoubleClicked(QTreeWidgetItem *tWI)
     {
         const auto params = tWI->data(0, Qt::UserRole + 3).value<QHash<QByteArray, QByteArray>>();
         QByteArray rawHeaders;
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         for (auto it = params.cbegin(), itEnd = params.cend(); it != itEnd; ++it)
+#else
+        for (auto it = params.constBegin(), itEnd = params.constEnd(); it != itEnd; ++it)
+#endif
         {
             const auto &key = it.key();
             if (key == Playlist::Entry::UserAgentParam)
@@ -441,7 +455,12 @@ void PlaylistDock::next(bool playingError)
                     tWI = l.at(0);
                 else do
                 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 10, 0)
                     tWI = l.at(QRandomGenerator::global()->bounded(l.count()));
+#else
+                    // Qt4: Use qrand() for random number generation
+                    tWI = l.at(qrand() % l.count());
+#endif
                     if (PlaylistWidget::getFlags(tWI) & Playlist::Entry::Skip)
                     {
                         //Don't play skipped item.
@@ -631,7 +650,12 @@ void PlaylistDock::delEntries(bool fromDisk)
         {
             if (const QString url = getUrl(tWI); url.startsWith("file://"))
             {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 15, 0)
                 canDeleteTWI = QFile::moveToTrash(url.mid(7));
+#else
+                // Qt4: moveToTrash doesn't exist, use remove() instead
+                canDeleteTWI = QFile::remove(url.mid(7));
+#endif
                 if (!canDeleteTWI)
                     diskDeleteFailed = true;
             }
diff --git a/src/gui/PlaylistDock.hpp b/src/gui/PlaylistDock.hpp
index 8b17403a..4ab2efa3 100644
--- a/src/gui/PlaylistDock.hpp
+++ b/src/gui/PlaylistDock.hpp
@@ -58,7 +58,7 @@ public:
     void setMode();
 
 private:
-    void showEvent(QShowEvent *e) override;
+    void showEvent(QShowEvent *e);
 
 private:
     void expandTree(QTreeWidgetItem *);
diff --git a/src/gui/PlaylistWidget.cpp b/src/gui/PlaylistWidget.cpp
index c9d1c266..75a006c3 100644
--- a/src/gui/PlaylistWidget.cpp
+++ b/src/gui/PlaylistWidget.cpp
@@ -81,7 +81,7 @@ static inline MenuBar::Playlist *playlistMenu()
 class PlaylistItem : public QTreeWidgetItem
 {
 public:
-    bool operator <(const QTreeWidgetItem &other) const override
+    bool operator <(const QTreeWidgetItem &other) const
     {
         if (auto tw = treeWidget())
         {
@@ -236,9 +236,7 @@ AddThr::AddThr(PlaylistWidget &pLW) :
     pLW(pLW),
     inProgress(false)
 {
-    connect(this, &QThread::finished, this, [this] {
-        running = false;
-    });
+    connect(this, SIGNAL(finished()), this, SLOT(handleThreadFinished()));
     connect(this, SIGNAL(finished()), this, SLOT(finished()));
 }
 
@@ -641,12 +639,26 @@ void AddThr::finished()
     inProgress = false;
 }
 
+// Qt4: Helper slot implementation
+void AddThr::handleThreadFinished()
+{
+    running = false;
+}
+
 /*PlaylistWidget class*/
 PlaylistWidget::PlaylistWidget() :
     addThr(*this),
     updateEntryThr(*this),
     repaintAll(false)
 {
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+    // Qt4: Register QHash<QByteArray, QByteArray> as a metatype
+    qRegisterMetaType<ByteArrayHash>("ByteArrayHash");
+    qRegisterMetaType<ByteArrayHash>("QHash<QByteArray,QByteArray>");
+    // Qt4: Register the struct used to defer newEntry()'s icon-setting work
+    // to the GUI thread via insertEntryItem() (see NewEntryData).
+    qRegisterMetaType<NewEntryData>("NewEntryData");
+#endif
     setContextMenuPolicy(Qt::CustomContextMenu);
     setEditTriggers(QAbstractItemView::NoEditTriggers);
     setDragDropMode(QAbstractItemView::InternalMove);
@@ -657,7 +669,11 @@ PlaylistWidget::PlaylistWidget() :
     setAnimated(true);
     header()->setStretchLastSection(false);
     setHeaderHidden(true);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     header()->setSectionResizeMode(0, QHeaderView::Stretch);
+#else
+    header()->setResizeMode(0, QHeaderView::Stretch);
+#endif
     header()->hideSection(1);
     setItemsResizeToContents(true);
 
@@ -669,7 +685,7 @@ PlaylistWidget::PlaylistWidget() :
     connect(&animationTimer, SIGNAL(timeout()), this, SLOT(animationUpdate()));
     connect(&addTimer, SIGNAL(timeout()), this, SLOT(addTimerElapsed()));
     connect(&addThr, SIGNAL(status(bool)), this, SIGNAL(addStatus(bool)));
-    connect(playlistMenu(), &MenuBar::Playlist::aboutToShow, this, &PlaylistWidget::createExtensionsMenu);
+    connect(playlistMenu(), SIGNAL(aboutToShow()), this, SLOT(createExtensionsMenu()));
 }
 
 QString PlaylistWidget::getUrl(QTreeWidgetItem *tWI) const
@@ -683,7 +699,11 @@ void PlaylistWidget::setItemsResizeToContents(bool b)
 {
     const QHeaderView::ResizeMode rm = b ? QHeaderView::ResizeToContents : QHeaderView::Fixed;
     for (int i = 1; i <= 2; ++i)
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         header()->setSectionResizeMode(i, rm);
+#else
+        header()->setResizeMode(i, rm);
+#endif
 }
 
 void PlaylistWidget::sortCurrentGroup(int column, Qt::SortOrder sortOrder)
@@ -875,7 +895,11 @@ void PlaylistWidget::refresh(REFRESH Refresh)
         for (int i = 0; i < queue.size(); i++)
         {
             if (!items.contains(queue.at(i)))
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+                queue.remove(i--);
+#else
                 queue.removeAt(i--);
+#endif
             else
                 queue.at(i)->setText(1, QString::number(i + 1));
         }
@@ -985,10 +1009,15 @@ QTreeWidgetItem *PlaylistWidget::newGroup(const QString &name, const QString &ur
     if (existingEntries)
         entryCreated(url, insertChildAt, *existingEntries);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QMetaObject::invokeMethod(this, [this, tWI, url, parent, insertChildAt] {
         QMPlay2GUI.setTreeWidgetItemIcon(tWI, url.isEmpty() ? *QMPlay2GUI.groupIcon : *QMPlay2GUI.folderIcon, 0, this);
         insertItem(tWI, parent, insertChildAt);
     });
+#else
+    // Qt4: QMetaObject::invokeMethod() has no lambda overload
+    QMetaObject::invokeMethod(this, "insertGroupItem", Q_ARG(QTreeWidgetItem *, tWI), Q_ARG(QString, url), Q_ARG(QTreeWidgetItem *, parent), Q_ARG(int, insertChildAt));
+#endif
 
     return tWI;
 }
@@ -1009,14 +1038,33 @@ QTreeWidgetItem *PlaylistWidget::newEntry(const Playlist::Entry &entry, QTreeWid
     if (existingEntries)
         entryCreated(entry.url, insertChildAt, *existingEntries);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QMetaObject::invokeMethod(this, [this, tWI, icon, parent, insertChildAt] {
         setEntryIcon(icon, tWI);
         insertItem(tWI, parent, insertChildAt);
     });
+#else
+    // Qt4: QMetaObject::invokeMethod() has no lambda overload
+    NewEntryData newEntryData{tWI, icon, parent, insertChildAt};
+    QMetaObject::invokeMethod(this, "insertEntryItem", Q_ARG(NewEntryData, newEntryData));
+#endif
 
     return tWI;
 }
 
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+void PlaylistWidget::insertGroupItem(QTreeWidgetItem *tWI, QString url, QTreeWidgetItem *parent, int insertChildAt)
+{
+    QMPlay2GUI.setTreeWidgetItemIcon(tWI, url.isEmpty() ? *QMPlay2GUI.groupIcon : *QMPlay2GUI.folderIcon, 0, this);
+    insertItem(tWI, parent, insertChildAt);
+}
+void PlaylistWidget::insertEntryItem(NewEntryData data)
+{
+    setEntryIcon(data.icon, data.tWI);
+    insertItem(data.tWI, data.parent, data.insertChildAt);
+}
+#endif
+
 void PlaylistWidget::setEntryIcon(const QIcon &icon, QTreeWidgetItem *tWI)
 {
     Q_ASSERT(QThread::currentThread() == thread());
@@ -1053,7 +1101,11 @@ void PlaylistWidget::quickSyncScanDirs(const QString &pth, QTreeWidgetItem *par,
         if (urlIdx > -1 && isGroup == QFileInfo(fullPth).isDir())
         {
             existingEntries.prepend(itemFileName);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+            dirEntries.remove(urlIdx);
+#else
             dirEntries.removeAt(urlIdx);
+#endif
             if (isGroup && recursive)
             {
                 if (!fullPth.endsWith('/'))
@@ -1100,7 +1152,7 @@ void PlaylistWidget::createExtensionsMenu()
             actions = QMPlay2Ext->getActions(entryName, entryLength, url, addressPrefixName, param);
         else
             actions = QMPlay2Ext->getActions(entryName, entryLength, entryUrl);
-        for (QAction *act : std::as_const(actions))
+        for (QAction *act : actions)
         {
             act->setParent(extensions);
             extensions->addAction(act);
diff --git a/src/gui/PlaylistWidget.hpp b/src/gui/PlaylistWidget.hpp
index dc4cda3b..a7d4e8fd 100644
--- a/src/gui/PlaylistWidget.hpp
+++ b/src/gui/PlaylistWidget.hpp
@@ -34,7 +34,7 @@ class QTreeWidgetItem;
 class PlaylistWidget;
 class Demuxer;
 
-class UpdateEntryThr final : public QThread
+class UpdateEntryThr : public QThread
 {
     Q_OBJECT
 
@@ -51,7 +51,7 @@ public:
     }
 
 private:
-    void run() override;
+    void run();
 
     QAtomicInt pendingUpdates;
     IOController<> ioCtrl;
@@ -84,7 +84,7 @@ private slots:
     void finished();
 };
 
-class AddThr final : public QThread
+class AddThr : public QThread
 {
     Q_OBJECT
 public:
@@ -101,7 +101,7 @@ private slots:
     void modifyItemFlags(QTreeWidgetItem *tWI, int flags);
     void deleteTreeWidgetItem(QTreeWidgetItem *tWI);
 private:
-    void run() override;
+    void run();
 
     bool add(const QStringList &urls, QTreeWidgetItem *parent, const Functions::DemuxersInfo &demuxersInfo, QStringList *existingEntries = nullptr, bool loadList = false);
     QTreeWidgetItem *insertPlaylistEntries(const Playlist::Entries &entries, QTreeWidgetItem *parent, const Functions::DemuxersInfo &demuxersInfo, int insertChildAt, QStringList *existingEntries);
@@ -118,16 +118,32 @@ public:
     bool running = false;
 private slots:
     void finished();
+    // Qt4: Helper slot for lambda conversion
+    void handleThreadFinished();
 signals:
     void status(bool s);
 };
 
-class PlaylistWidget final : public QTreeWidget
+class PlaylistWidget : public QTreeWidget
 {
     friend class AddThr;
     friend class UpdateEntryThr;
     Q_OBJECT
 public:
+#if QT_VERSION < 0x050000
+    // Qt4: QMetaObject::invokeMethod() has no lambda overload, so newEntry()
+    // defers through insertEntryItem(), bundling all its arguments into a
+    // single struct instead of passing QIcon through Q_ARG() directly (see
+    // ItemUpdated below, which does the same for a very similar purpose).
+    struct NewEntryData
+    {
+        QTreeWidgetItem *tWI;
+        QIcon icon;
+        QTreeWidgetItem *parent;
+        int insertChildAt;
+    };
+#endif
+
     enum CHILDREN {ONLY_GROUPS = 0x10, ONLY_NON_GROUPS = 0x100, ALL_CHILDREN = ONLY_GROUPS | ONLY_NON_GROUPS};
     enum REFRESH  {REFRESH_QUEUE = 0x10, REFRESH_GROUPS_TIME = 0x100, REFRESH_CURRPLAYING = 0x1000, REFRESH_ALL = REFRESH_QUEUE | REFRESH_GROUPS_TIME | REFRESH_CURRPLAYING};
 
@@ -196,14 +212,16 @@ private:
 
     void quickSyncScanDirs(const QString &pth, QTreeWidgetItem *par, bool &mustRefresh, bool recursive, QTreeWidgetItem *&itemToNull);
 
+private slots:
     void createExtensionsMenu();
 
-    void mouseMoveEvent(QMouseEvent *) override;
-    void dragEnterEvent(QDragEnterEvent *) override;
-    void dragMoveEvent(QDragMoveEvent *) override;
-    void dropEvent(QDropEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    void scrollContentsBy(int dx, int dy) override;
+private:
+    void mouseMoveEvent(QMouseEvent *);
+    void dragEnterEvent(QDragEnterEvent *);
+    void dragMoveEvent(QDragMoveEvent *);
+    void dropEvent(QDropEvent *);
+    void paintEvent(QPaintEvent *);
+    void scrollContentsBy(int dx, int dy);
 
     QRect getArcRect(int size);
 
@@ -222,6 +240,12 @@ private:
     int rotation;
 private slots:
     void insertItem(QTreeWidgetItem *, QTreeWidgetItem *, int insertChildAt);
+#if QT_VERSION < 0x050000
+    // Qt4: QMetaObject::invokeMethod() has no lambda overload, so newGroup()/
+    // newEntry() defer through these named slots instead.
+    void insertGroupItem(QTreeWidgetItem *tWI, QString url, QTreeWidgetItem *parent, int insertChildAt);
+    void insertEntryItem(NewEntryData data);
+#endif
     void popupContextMenu(const QPoint &);
     void animationUpdate();
     void addTimerElapsed();
@@ -232,3 +256,10 @@ signals:
     void visibleItemsCount(int);
     void addStatus(bool s);
 };
+
+#if QT_VERSION < 0x050000
+// Qt4: Register QHash<QByteArray, QByteArray> as a metatype
+// Use typedef to avoid comma in macro
+typedef QHash<QByteArray, QByteArray> ByteArrayHash;
+Q_DECLARE_METATYPE(ByteArrayHash)
+#endif
